/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL  (3 * 1000)

typedef struct _WmStateHint {
    unsigned long state;
    Window        icon;
} WmStateHint;

static void WithdrawCB(), Withdraw2Icon(), Icon2Normal();
static void IconifyCB(), Icon2Withdraw(), Withdraw2Normal();
static void MappedEH(), StateEH();

main(argc, argv)
    int argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, withdraw, iconify;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Wmstate", NULL, 0,
                               &argc, argv, NULL, al, ac);

    /* (1) ȥåץ٥ΥɥޥåפޤԤ */
    XtAddEventHandler(toplevel, StructureNotifyMask, False, MappedEH, NULL);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (2) [ű ->  -> ̾] ܥ */
    ac = 0;
    withdraw = XmCreatePushButton(panel, "withdraw", al, ac);
    XtManageChild(withdraw);
    XtAddCallback(withdraw, XmNactivateCallback, WithdrawCB, toplevel);

    /* (3) [ -> ű -> ̾] ܥ */
    ac = 0;
    iconify = XmCreatePushButton(panel, "iconify", al, ac);
    XtManageChild(iconify);
    XtAddCallback(iconify, XmNactivateCallback, IconifyCB, toplevel);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [ű ->  -> ̾] ܥ󤬲줿ȤΥХå */
static void WithdrawCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;

    /* (5) ޥåפ Withdrawn ֤ˤ */
    XtUnmapWidget(toplevel);

    /* (6) 3 ø Withdraw2Icon() ƤӽФ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Withdraw2Icon, toplevel);
}

/* (7) WithdrawCB()  3 ø˸ƤӽФ */
static void Withdraw2Icon(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;

    /* (8) Withdrawn ֤饢֤ѹ */
    XtVaSetValues(toplevel, XmNinitialState, IconicState, NULL);
    XtMapWidget(toplevel);

    /* (9) 3 ø Icon2Normal() ƤӽФ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Icon2Normal, toplevel);
}

/* (10) Withdraw2Icon()  3 ø˸ƤӽФ */
static void Icon2Normal(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;

    /* (11) ֤̤ξ֤᤹ */
    XtMapWidget(toplevel);
}

/* (12) [ -> ű -> ̾] ܥ󤬲줿ȤΥХå */
static void IconifyCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;

    /* (13) ֤ˤ */
    XIconifyWindow(XtDisplay(toplevel), XtWindow(toplevel),
                   XScreenNumberOfScreen(XtScreen(toplevel)));

    /* (14) 3 ø Icon2Withdraw() ƤӽФ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Icon2Withdraw, toplevel);
}

/* (15) IconifyCB()  3 ø˸ƤӽФ */
static void Icon2Withdraw(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;
    XtIntervalId timeout_id;
    XUnmapEvent unmap;

    /* (16) ֤ Withdrawn ֤ѹ */
    /* Unmap Υ٥ȹ¤Τ */
    unmap.type = UnmapNotify;
    unmap.display = XtDisplay(toplevel);
    unmap.event = RootWindowOfScreen(XtScreen(toplevel));
    unmap.window = XtWindow(toplevel);
    unmap.from_configure = False;
    /* Υ٥Ȥ롼ȡɥƤ */
    XSendEvent(XtDisplay(toplevel), RootWindowOfScreen(XtScreen(toplevel)),
              False, SubstructureRedirectMask | SubstructureNotifyMask, &unmap);

    /* (17) 3 ø Withdraw2Normal() ƤӽФ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(toplevel),
                                 INTERVAL, Withdraw2Normal, toplevel);
}

/* (18) Icon2Withdraw()  3 ø˸ƤӽФ */
static void Withdraw2Normal(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget toplevel = (Widget)client_data;

    /* (19) Withdraw ֤̤ξ֤᤹ */
    XtVaSetValues(toplevel, XmNinitialState, NormalState, NULL);
    XtMapWidget(toplevel);
}

/* (20) ǽ˥ȥåץ٥Υɥޥåפ줿Ȥ˸ƤӽФ */
static void MappedEH(w, client_data, event, dispatch)
    Widget     w;
    XtPointer  client_data;
    XEvent    *event;
    Boolean   *dispatch;
{
    if (event->type == MapNotify) {
        /* (21) ȥåץ٥ΥɥΥץѥƥѲ */
        XtAddEventHandler(w, PropertyChangeMask, False, StateEH, NULL);
        XtRemoveEventHandler(w, StructureNotifyMask, False, MappedEH, NULL);
    }
}

/* (22) ȥåץ٥ΥɥΥץѥƥѲȤ˸ƤӽФ */
static void StateEH(w, client_data, event, dispatch)
    Widget     w;
    XtPointer  client_data;
    XEvent    *event;
    Boolean   *dispatch;
{
    Atom xa_wm_state, actual_type;
    int actual_format;
    unsigned long nitems, left;
    WmStateHint *state_hint;

    /* (23) "WM_STATE" Υȥ */
    xa_wm_state = XmInternAtom(XtDisplay(w), "WM_STATE", False);

    /* (24) ȥåץ٥Υɥ "WM_STATE" ץѥƥɤ */
    if (XGetWindowProperty(XtDisplay(w), XtWindow(w),
                           xa_wm_state, 0, 2, False, xa_wm_state,
                           &actual_type, &actual_format, &nitems, &left,
                           (unsigned char **)&state_hint)
                == Success && actual_type == xa_wm_state && nitems == 2) {

        /* (25) "WM_STATE" ͤǸߤΥɥ֤Ƚ */
        switch (state_hint->state) {
        case WithdrawnState:
                printf("Withdrawn State\n");
                break;
        case NormalState:
                printf("Normal State\n");
                break;
        case IconicState:
                printf("Iconic State\n");
                break;
        default:
                printf("Unknown State\n");
                break;
        }
    }
    else {
        fprintf(stderr, "Couldn't get window state.\n");
    }
}
